import javax.swing.*;
import java.util.*;
import javax.swing.border.*;
import javax.swing.plaf.basic.*;
import javax.swing.plaf.metal.*;
import java.awt.Graphics;
import java.awt.BorderLayout;
import java.awt.Rectangle;
import java.awt.Color;
import java.awt.Point;
import java.awt.Toolkit;
import java.awt.Image;
import java.awt.Component;
import java.awt.image.*;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

/** 
 *	Atua como modelo de comportamento do programa. Ele  quem vai se encarregar de construir toda a interface 
 * do programa e que vai realizar as ligaes MVC.
 */

public class PolyPlace extends JFrame
{
	private ViewGraphicsPanel canvas = null;
	private TwoPolygonGenerator twoPolygonGenerator = null;
	private PolygonManager polygonManager = null;
	private JMenuBar menuBar = new JMenuBar();


	public PolyPlace()
	{
		canvas = new ViewGraphicsPanel(0, 0, 500, 500);
		polygonManager = new PolygonManager();
		twoPolygonGenerator = new TwoPolygonGenerator(polygonManager);
//////		canvas.setBackground(new Color(200, 200, 200));
		JPanel panelCanvasHolder = new JPanel();
//////		panelCanvasHolder.setBackground(new Color(231, 153, 70));
		panelCanvasHolder.setBackground(new Color(231, 153, 255));
		panelCanvasHolder.setBorder(new LineBorder(new Color(50, 50, 180), 1));
		panelCanvasHolder.add(new JScrollPane(canvas));
		this.getContentPane().add(panelCanvasHolder, BorderLayout.CENTER);
		this.setJMenuBar(menuBar);
		this.pack();
		this.setSize(700, 700);
		this.addWindowListener(new WindowAdapter() {public void windowClosing(WindowEvent e)	{System.exit(0);}});
		link();
		this.setVisible(true);
	}


	public void link()
	{
		// Adiciona listeners para os eventos do canvas.
		canvas.addMouseListener(polygonManager);
		canvas.addMouseMotionListener(polygonManager);
//////		canvas.addKeyListener(polygonManager);


		polygonManager.addPolygonListener(twoPolygonGenerator);

		JMenu menuTmp = new JMenu((String) polygonManager.getAction().getValue(Action.NAME));
		menuTmp.add(polygonManager.getAction());
		menuBar.add(menuTmp);
		menuTmp = new JMenu((String) twoPolygonGenerator.getAction().getValue(Action.NAME));
		menuTmp.add(twoPolygonGenerator.getAction());
		menuBar.add(menuTmp);

		// Para polygonManager poder repintar os polgonos em canvas quando canvas sofrer
		// um repaint.
		canvas.addRefreshListener(polygonManager);

		// Para polygonManager poder capturar um objeto Graphics quando necessitar redesenhar
 		// alguma coisa.
		polygonManager.addViewGraphics(canvas);
	}


	public static void main(String [] args)
	{
		try
		{
			PolyPlace comportamento = new PolyPlace();
		}
		catch(Exception exc)
		{
			System.out.println("eiM public static void main(String [] args) Exception com texto: " + exc.getLocalizedMessage() + "nome da mesma:" + exc.toString());
		}
	}

}