	import javax.swing.*;
import java.awt.Graphics;
import java.awt.event.ItemEvent;
import java.awt.event.ActionEvent;
import java.awt.event.ItemListener;
import java.awt.event.ActionListener;
import java.awt.Container;
import java.awt.Component;
import java.awt.geom.Rectangle2D;
import java.awt.BorderLayout;
import java.util.EventListener;
import java.util.List;
import java.util.LinkedList;
import java.util.ListIterator;
import rob.math.geom.*;


public class TwoPolygonGenerator implements PolygonListener
{
	public static final int UNION = 1;
	public static final int INTERSECTION = 2;

	private JDialog root;
	private JPanel pnlN1DownRoot;
	private JPanel pnlC1DownRoot;
	private JPanel pnlS1DownRoot;

	private JButton btnOkDownS1;
	private JButton btnCancelDownS1;
	private JButton btnPoly1DownN1;
	private JButton btnPoly2DownN1;

	private ButtonGroup opGroup;
	private JRadioButton union;
	private JRadioButton intersection;

	private int kindOfOperation = UNION;
	private IPolygon poly1 = null;
	private IPolygon poly2 = null;
	private boolean choosingPolygon1 = false;
	private boolean choosingPolygon2 = false;

	private PolygonManager polygonHolder;

	public TwoPolygonGenerator(PolygonManager newOne)
	{
		polygonHolder = newOne;
	}

	public Action getAction()
	{
		return new PolygonBooleanOperationsControl(null);
	}


	public void polygonSelected(PolygonEvent polyEvt)
	{
		if (choosingPolygon1)
		{
			poly1 = polyEvt.getPolygon();
			btnPoly1DownN1.setText("Polygon 1 chose");
			root.pack();
			choosingPolygon1 = false;
		}
		else if (choosingPolygon2)
		{
			poly2 = polyEvt.getPolygon();
			btnPoly2DownN1.setText("Polygon 2 chose");
			root.pack();
			choosingPolygon2 = false;
		}
		if (poly1 != null && poly2 != null)
		{
			btnOkDownS1.setEnabled(true);
		}
	}


	public void polygonRemoved(PolygonEvent polyEvt)	{}
	public void polygonAdded(PolygonEvent polyEvt)		{}
	public void polygonDeselected(PolygonEvent polyEvt)	{}


	public class  PolygonBooleanOperationsControl extends AbstractControlAction
	{
		JFrame frm = null;

		public PolygonBooleanOperationsControl(Component popi) {super("Perform boolean", popi); frm = (JFrame) popi;}


		public void actionPerformed(ActionEvent evt)
		{
			poly1 = null; poly2 = null;
			TwoPolygonGenerator.this.polygonHolder.addPolygonListener(TwoPolygonGenerator.this);

			root = new JDialog(frm, "Boolean operations", false);
			pnlN1DownRoot = new JPanel();
			pnlC1DownRoot = new JPanel();
			pnlS1DownRoot = new JPanel();

			btnOkDownS1 = new JButton("Ok");
			btnOkDownS1.addActionListener(new OkListener());
			btnOkDownS1.setEnabled(false);

			btnCancelDownS1 = new JButton("Cancel");
			btnCancelDownS1.addActionListener(new CancelListener());

			btnPoly1DownN1 = new JButton("Choose polygon 1");
			btnPoly1DownN1.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent evt) {
					choosingPolygon1 = true; choosingPolygon2 = false;
					btnPoly1DownN1.setText("Polygon 1 is being chosen");
					root.pack();
				}
			});

			btnPoly2DownN1 = new JButton("Choose polygon 2");
			btnPoly2DownN1.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent evt) {
					choosingPolygon2 = true; choosingPolygon1 = false;
					btnPoly2DownN1.setText("Polygon 2 is being chosen");
					root.pack();
				}
			});

			opGroup = new ButtonGroup();
			union = new JRadioButton("Union");
			union.addItemListener(new ItemListener() {
				public void itemStateChanged(ItemEvent event) {
					if(union.isSelected())	kindOfOperation = UNION;
				}
			});

			intersection = new JRadioButton("Intersection");
			intersection.addItemListener(new ItemListener() {
				public void itemStateChanged(ItemEvent event) {
					if(intersection.isSelected())	kindOfOperation = INTERSECTION;
				}
			});

			opGroup.add(union); opGroup.add(intersection);
			union.setSelected(true);

			pnlN1DownRoot.add(btnPoly1DownN1);
			pnlN1DownRoot.add(btnPoly2DownN1);

			pnlC1DownRoot.add(union);
			pnlC1DownRoot.add(intersection);

			pnlS1DownRoot.add(btnOkDownS1);
			pnlS1DownRoot.add(btnCancelDownS1);

			Container rootContentPane = root.getContentPane();
			rootContentPane.setLayout(new BorderLayout());
			rootContentPane.add(BorderLayout.NORTH, pnlN1DownRoot);
			rootContentPane.add(BorderLayout.CENTER, pnlC1DownRoot);
			rootContentPane.add(BorderLayout.SOUTH, pnlS1DownRoot);

			root.pack();
			root.setVisible(true);
		}
	}


	public class OkListener implements ActionListener
	{	
		public OkListener()					{}
		public void actionPerformed(ActionEvent evt)
		{
			TwoPolygonsCrossings polyCrosses = new TwoPolygonsCrossings(TwoPolygonGenerator.this.poly1, TwoPolygonGenerator.this.poly2);
			List newList = null;
			if (kindOfOperation == TwoPolygonGenerator.UNION)
				newList = polyCrosses.getUnion();
			else
				newList = polyCrosses.getIntersection();
			TwoPolygonGenerator.this.polygonHolder.removePolygonListener(TwoPolygonGenerator.this);
			TwoPolygonGenerator.this.polygonHolder.removePolygon(TwoPolygonGenerator.this.poly1);
			TwoPolygonGenerator.this.polygonHolder.removePolygon(TwoPolygonGenerator.this.poly2);
			ListIterator listItPolygons = newList.listIterator();
			List listTmp = null;
			while (listItPolygons.hasNext())
			{
				listTmp = (List) listItPolygons.next();
				if (listTmp != null)
					TwoPolygonGenerator.this.polygonHolder.addPolygon(listTmp);
			}
			root.setVisible(false);
		}
	}


	public class CancelListener implements ActionListener
	{	
		public CancelListener()					{}
		public void actionPerformed(ActionEvent evt)
		{
			TwoPolygonGenerator.this.polygonHolder.removePolygonListener(TwoPolygonGenerator.this);
			root.setVisible(false);
		}
	}
}