import javax.swing.*;
import java.util.*;
import java.security.*;
import java.awt.image.*;
import java.awt.Component;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Rectangle;
import java.awt.Color;
import java.awt.Point;
import java.awt.Dimension;
import java.awt.Toolkit;
import java.awt.Image;
import java.awt.BorderLayout;
import java.awt.Shape;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.geom.*;


public class ViewGraphicsPanel extends JPanel implements ViewGraphics
{	
	private Graphics2D grPaint = null; // Guarda o objeto Graphics usado durante o repaint().
	private List vectRefreshListener = new Vector(5,5);


	public ViewGraphicsPanel(Rectangle2D r)	{this((int) r.getX(), (int) r.getY(), (int) r.getWidth(), (int) r.getHeight());}

	public ViewGraphicsPanel(int x, int y, int width, int height)
	{
		setMinimumSize(new Dimension(50, 50));
		setPreferredSize(new Dimension(500, 500));
		setMaximumSize(new Dimension(1000, 1000));
	}


	public void addRefreshListener(RefreshListener newListener)
	{
		vectRefreshListener.add(newListener);
	}


	public void removeRefreshListener(RefreshListener newListener)
	{
		vectRefreshListener.remove(newListener);
	}


/////////
////////////////   METODOS SOBREESCRITOS DE JPANEL
/////////
	public Graphics getGraphics()
	{
		if (grPaint != null)
			return grPaint.create();
		return super.getGraphics();
	}


	public Rectangle2D getVisibleArea()
	{
		return getBounds();
	}


	public void paint(Graphics g)
	{
		super.paint(g);
		grPaint = (Graphics2D) g.create();
		ListIterator listItModel = vectRefreshListener.listIterator();
		while (listItModel.hasNext())
			((RefreshListener) listItModel.next()).refresh(null);
		grPaint.dispose();
		grPaint = null;
	}
}