/******
 *****  Essa classe  especializada em criar janela de seleo de arquivos.
 ***** Ela retorna o nome do arquivo selecionado, null se cancel.
 *****/
package rob.GUI;

import java.io.File;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.filechooser.*;
import javax.swing.text.*;
import javax.swing.event.*;
import java.util.*;


public class FileChooserWindow extends JFileChooser
{

	public static final String abrir = "abrir";
	public static final String salvar = "salvar";

	private String tipoEscolhido;
	private File arquivo;
	private Component pai;
	private boolean verifyName;


	public FileChooserWindow(String tipo, Component pai, boolean verifyName)
	{
		this(tipo, pai, new FileFilters(" "), verifyName);
	}


	public FileChooserWindow(String initialPath, String tipo, Component pai, boolean verifyName)
	{
		this(initialPath, tipo, pai, new FileFilters(" "), verifyName);
	}


	public FileChooserWindow(String tipo, Component pai, FileFilter filtro, boolean verifyName)
	{
		super(FileSystemView.getFileSystemView());
		arquivo = null;
		this.pai = pai;
		tipoEscolhido = tipo;
		setDialogTitle(tipoEscolhido);
		setApproveButtonText(tipoEscolhido);
		addChoosableFileFilter(filtro);
		this.verifyName = verifyName;
	}


	public FileChooserWindow(String initialPath, String tipo, Component pai, FileFilter filtro, boolean verifyName)
	{
		super(initialPath, FileSystemView.getFileSystemView());
		arquivo = null;
		this.pai = pai;
		tipoEscolhido = tipo;
		setDialogTitle(tipoEscolhido);
		setApproveButtonText(tipoEscolhido);
		addChoosableFileFilter(filtro);
		this.verifyName = verifyName;
	}


	public String getFileName()
	{
		File arquivo = null;
		int estado = 0;
		String str = null;
		while (true)
		{
			estado = showOpenDialog(pai);
			arquivo = getSelectedFile();
			if (arquivo != null && arquivo.getName() != null && estado == JFileChooser.APPROVE_OPTION)
			{
				str = arquivo.getPath();
				if (verifyName && !arquivo.exists())
					JOptionPane.showMessageDialog(this, "O arquivo no existe!");
				else
					break;
			}	
			else if (estado == JFileChooser.CANCEL_OPTION)
				break;
		}
		return str;
	}
}