package rob.GUI;


import javax.swing.*;
import java.lang.*;
import java.util.*;
import java.security.*;
import java.awt.GridLayout;
import java.awt.FlowLayout;
import java.awt.BorderLayout;
import java.awt.image.*;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Rectangle;
import java.awt.Color;
import java.awt.Frame;
import java.awt.Component;
import java.awt.Container;
import java.awt.Point;
import java.awt.Toolkit;
import java.awt.Image;
import java.awt.Insets;
import java.awt.Dimension;
import java.awt.BorderLayout;
import java.awt.Rectangle;
import java.awt.geom.Rectangle2D;
import java.awt.geom.AffineTransform;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import rob.util.*;
import rob.MVC.*;
import rob.exceptions.*;


/**
 *	Classe que auxilia a construo de interfaces grficas padres.
 */

public class GUIFactory
{
	
	public static String DEFAULT_PATH = "c:\\java\\projetos\\Image";
	public static String FILE = "File";
	public static String EDIT = "Edit";
	public static String PLUGIN = "Plug in";
	public static String HELP = "Help";
	
	protected GUIFactory()	{}

	public static JMenuBar menuDefaultFactory()
	{
		JMenuBar retVal = new JMenuBar();
		return retVal;
	}

	
	public static String getEntireFileName(Component parent, String kindOfAction, String filter, boolean verifyName)
	{
		return getEntireFileName(parent, kindOfAction, filter, " ", verifyName);
	}


	public static String getEntireFileName(Component parent, String kindOfAction, String [] filters, boolean verifyName)
	{
		return getEntireFileName(parent, kindOfAction, filters, " ", verifyName);
	}


	public static String getEntireFileName(Component parent, String kindOfAction, String filter, String description, boolean verifyName)
	{
		FileChooserWindow openFile = new FileChooserWindow(GUIFactory.DEFAULT_PATH, kindOfAction, parent, verifyName);
		FileFilters imgFilters = new FileFilters(filter, description);
		openFile.addChoosableFileFilter(imgFilters);
		return openFile.getFileName();
	}


	public static String getEntireFileName(Component parent, String kindOfAction, String [] filters, String description, boolean verifyName)
	{
		FileChooserWindow openFile = new FileChooserWindow(GUIFactory.DEFAULT_PATH, kindOfAction, parent, verifyName);
		FileFilters imgFilters = new FileFilters(filters, description);
		openFile.addChoosableFileFilter(imgFilters);
		return openFile.getFileName();
	}


	public static Rectangle getZoom(Component parent, String title, String subTitle)
	{
		return GUIFactory.displayGetRectMenu(parent, title, subTitle, "ponto central: X", "ponto central: X", "zoom", "intil", null, false);
	}


	public static Rectangle getZoom(Component parent, String title, String subTitle, Rectangle2D defaults, boolean setTheSameRect)
	{
		return GUIFactory.displayGetRectMenu(parent, title, subTitle, "ponto central: X", "ponto central: X", "zoom", "intil", defaults, setTheSameRect);
	}


	public static Rectangle getBounds(Component parent, String title, String subTitle)
	{
		return GUIFactory.displayGetRectMenu(parent, title, subTitle, "X", "Y", "Width", "Height", null, false);
	}


	public static Rectangle getBounds(Component parent, String title, String subTitle, Rectangle defaults)
	{
		return GUIFactory.displayGetRectMenu(parent, title, subTitle, "X", "Y", "Width", "Height", defaults, false);
	}


	public static Rectangle getBounds(Component parent, String title, String subTitle, Rectangle defaults, boolean setTheSameRect)
	{
		return GUIFactory.displayGetRectMenu(parent, title, subTitle, "X", "Y", "Width", "Height", defaults, setTheSameRect);
	}


	public static Rectangle displayGetRectMenu(Component parent, String title, String subTitle, String strLabelX, String strLabelY, String strLabelWidth, String strLabelHeight, Rectangle2D rectPassed, boolean setTheSameRect)
	{
		System.out.print("Xiddd");
		JPanel holder 	= new JPanel(new BorderLayout());
		JPanel holdFields = new JPanel(new GridLayout(2, 4));
		JPanel holdButtons = new JPanel(new FlowLayout());
		JTextField x 	= new JTextField("0");
		JTextField y 	= new JTextField("0");
		JTextField width  = new JTextField("0");
		JTextField height	= new JTextField("0");
		JButton ok		= new JButton("Ok");
		JButton cancel 	= new JButton("Cancel");
		holdFields.add(new JLabel(strLabelX)); holdFields.add(x);
		holdFields.add(new JLabel(strLabelY)); holdFields.add(y);
		holdFields.add(new JLabel(strLabelWidth)); holdFields.add(width);
		holdFields.add(new JLabel(strLabelHeight)); holdFields.add(height);
		holdButtons.add(ok);
		holdButtons.add(cancel);
		holder.add(new JLabel(title), BorderLayout.NORTH);
		holder.add(holdFields,        BorderLayout.CENTER);
		holder.add(holdButtons, 	BorderLayout.SOUTH);
		System.out.print("hfdiwgei!");
		if (rectPassed != null)
		{
			x.setText("" + rectPassed.getX());
			y.setText("" + rectPassed.getY());
			width.setText("" + rectPassed.getWidth());
			height.setText("" + rectPassed.getHeight());
		}
		System.out.print("hfdiwgei!");
		Frame parentFrame = getFrameForComponent(parent);
		CreateDialogListener tmpListener = new CreateDialogListener(holder, parentFrame);
		ok.addActionListener(tmpListener);
		cancel.addActionListener(tmpListener);
		tmpListener.launch();
		if (rectPassed != null && setTheSameRect == true)
			rectPassed.setRect(Integer.parseInt(x.getText()), Integer.parseInt(y.getText()), Integer.parseInt(width.getText()), Integer.parseInt(height.getText()));
		return new Rectangle(Integer.parseInt(x.getText()), Integer.parseInt(y.getText()), Integer.parseInt(width.getText()), Integer.parseInt(height.getText()));
	}


	private static class CreateDialogListener implements ActionListener
	{
		private JDialog jd;

		public CreateDialogListener(JPanel hold, Frame parent)	
		{		
			jd = new JDialog(parent, true);
			if (parent instanceof JFrame)
				jd.getContentPane().add(hold);
			else
				jd.add(hold);
			jd.pack();
		}

		public void launch()
		{
			jd.setVisible(true);
		}

		public void actionPerformed(ActionEvent evt)
		{
			System.out.println("UUUU");
			jd.setVisible(false);
			System.out.println("UUUU");
		}
	}


	public static Frame getNonClearingFrame(String name, Component c)
	{
		final Frame f = new Frame(name)	{public void update(Graphics g)	{paint(g);}};
		sizeContainerToComponent(f, c);
		centerFrame(f);
		f.setLayout(new BorderLayout());
		f.add(c, BorderLayout.CENTER);
		f.addWindowListener(new WindowAdapter()	{public void windowClosing(WindowEvent e)		{f.dispose();}});
		return f;
	}
  

	public static void sizeContainerToComponent(Container container, Component component)
	{
		if (container.isDisplayable() == false)	container.addNotify();
		Insets insets = container.getInsets();
		Dimension size = component.getPreferredSize();
		int width = insets.left + insets.right + size.width;
		int height = insets.top + insets.bottom + size.height;
		container.setSize(width, height);
	}
  

	public static void centerFrame(Frame f)
	{
		Dimension screen = Toolkit.getDefaultToolkit().getScreenSize();
		Dimension d = f.getSize();
		int x = (screen.width - d.width)/2;
		int y = (screen.height - d.height)/2;
		f.setLocation(x, y);
	}


	public static Kernel showKernelChooser(Component parent)	{return (new KernelChooser()).createKernelChooser(parent, true);}

	public static AffineTransform showScaleChooser(Component parent)	{return (new TransformChooser()).createScaleChooser(parent, true);}
	public static AffineTransform showTranslateChooser(Component parent)	{return (new TransformChooser()).createTranslateChooser(parent, true);}
	public static AffineTransform showRotateChooser(Component parent)	{return (new TransformChooser()).createRotateChooser(parent, true);}
	public static AffineTransform showRotateOverPointChooser(Component parent)	{return (new TransformChooser()).createRotateOverPointChooser(parent, true);}

    /**
     * Returns the specified component's Frame.
     * 
     * @param parentComponent the Component to check for a Frame
     * @return the Frame that contains the component, or the default
     *         frame if the component is null, or does not have a valid 
     *         Frame parent
     */
	public static Frame getFrameForComponent(Component parentComponent)
	{
		if (parentComponent == null)
			return getRootFrame();
		if (parentComponent instanceof Frame)
			return (Frame)parentComponent;
		return GUIFactory.getFrameForComponent(parentComponent.getParent());
	}


    /**
     * Returns the specified component's desktop pane.
     * 
     * @param parentComponent the Component to check for a desktop
     * @return the JDesktopPane that contains the component, or null
     *         if the component is null or does not have an ancestor 
     *         that is a JInternalFrame
     */
	public static JDesktopPane getDesktopPaneForComponent(Component parentComponent)
	{
		if(parentComponent == null)
			return null;
		if(parentComponent instanceof JDesktopPane)
			return (JDesktopPane) parentComponent;
		return GUIFactory.getDesktopPaneForComponent(parentComponent.getParent());
	}

	private static final Object sharedFrameKey = JOptionPane.class;

    /**
     * Sets the frame to use for class methods in which a frame is
     * not provided.
     *
     * @param newRootFrame the default Frame to use
     */
	public static void setRootFrame(Frame newRootFrame)
	{
		if (newRootFrame != null)
			GUIFactory.appContextPut(sharedFrameKey, newRootFrame);
		else
			GUIFactory.appContextRemove(sharedFrameKey);
	}


    /**
     * Returns the Frame to use for the class methods in which a frame
     * is not provided.
     *
     * @return the default Frame to use
     */
	public static Frame getRootFrame()
	{
		Frame sharedFrame = (Frame) GUIFactory.appContextGet(sharedFrameKey);
        	if (sharedFrame == null)
		{
			sharedFrame = GUIFactory.getSharedOwnerFrame();
			GUIFactory.appContextPut(sharedFrameKey, sharedFrame);
		}
		return sharedFrame;
	}


    /* Don't make these AppContext accessors public or protected --
     * since AppContext is in sun.awt in 1.2, we shouldn't expose it
     * even indirectly with a public API.
     */
    static Hashtable appContextTable = new Hashtable(2);

    static Object appContextGet(Object key) {
        /*if[JDK1.2]
        return sun.awt.AppContext.getAppContext().get(key);
        else[JDK1.2]*/
        return appContextTable.get(key);
        /*end[JDK1.2]*/
    }

    static void appContextPut(Object key, Object value) {
        /*if[JDK1.2]
        sun.awt.AppContext.getAppContext().put(key, value);
        else[JDK1.2]*/
        appContextTable.put(key, value);
        /*end[JDK1.2]*/
    }

    static void appContextRemove(Object key) {
        /*if[JDK1.2]
        sun.awt.AppContext.getAppContext().remove(key);
        else[JDK1.2]*/
        appContextTable.remove(key);
        /*end[JDK1.2]*/
    }

    // Don't use String, as it's not guaranteed to be unique in a Hashtable.
    private static final Object sharedOwnerFrameKey =
       new StringBuffer("SwingUtilities.sharedOwnerFrame");

    /**
     * Returns a toolkit-private, shared, invisible Frame
     * to be the owner for JDialogs and JWindows created with
     * null owners.
     */
    static Frame getSharedOwnerFrame() {
        Frame sharedOwnerFrame =
            (Frame)GUIFactory.appContextGet(sharedOwnerFrameKey);
        if (sharedOwnerFrame == null) {
            sharedOwnerFrame = new Frame() {
                public void show() {
                    // This frame can never be shown
                }
                public synchronized void dispose() {
                    try {
                        getToolkit().getSystemEventQueue();
                        super.dispose();
                    } catch (Exception e) {
                        // untrusted code not allowed to dispose
                    }
                }
            };
            GUIFactory.appContextPut(sharedOwnerFrameKey,
                                         sharedOwnerFrame);
        }
        return sharedOwnerFrame;
    }
}