package rob.GUI;

import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import javax.swing.plaf.basic.*;
import javax.swing.plaf.metal.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.geom.*;
import java.awt.image.*;
import java.util.HashMap;
import java.util.List;
import java.util.LinkedList;
import java.util.ListIterator;


public class KernelChooser
{
	private JDialog root;
	private JPanel pnlW1DownRoot;
	private JPanel pnlC1DownRoot;

	private JPanel pnlW2DownC1;
	private JPanel pnlE2DownC1;
	private JPanel pnlS2DownC1;
	private JLabel lblTitleDownC1;

	private JLabel lblKernelsDownW1;
	private JList listPredefinedKernelsDownW1;
	private HashMap mapPredefinedKernels;

	private JLabel lblNumberOfRowsDownW2;
	private JLabel lblNumberOfColumnsDownW2;
	private JTextField txtfNumberOfRowsDownW2;
	private JTextField txtfNumberOfColumnsDownW2;

	private JButton btnOkDownS2;
	private JButton btnCancelDownS2;
	private JButton btnCreateMatrixDownS2;
	private JButton btnClearMatrixDownS2;

	private JTextField [] arrayTxtfCellsDownE2;
	
	private Kernel krnlRetVal;
	private int rows;	
	private int columns;	


	public KernelChooser()
	{
		krnlRetVal  = null;
		root = null;
	}


	public Kernel swhowKernelChooser()
	{
		if (root != null)
			root.setVisible(true);
		return krnlRetVal;
	}


	public Kernel createKernelChooser(Component rooty, boolean showIt)
	{
		Frame rootRoot = GUIFactory.getFrameForComponent(rooty);
		root = new JDialog(rootRoot, "Kernel chooser", true);
		rows = 3;	columns = 3;	

System.out.print(" 1 ");

		// Cria todos os containters.
			pnlW1DownRoot = new JPanel();
			pnlC1DownRoot = new JPanel();
				pnlW2DownC1 = new JPanel();
				pnlE2DownC1 = new JPanel();
				pnlS2DownC1 = new JPanel();

System.out.print(" 1.1 ");

		// Configura primeiro o JPanel pnlW2DownC1.
		// Carrega os controles do kernel.
		GridBagLayout gb = new GridBagLayout();
		GridBagConstraints gbc = new GridBagConstraints();
		pnlW2DownC1.setLayout(gb);
		pnlW2DownC1.setBorder(new LineBorder(new Color(50, 50, 180), 1));
		pnlW2DownC1.setBackground(new Color(160, 160, 160));

		lblNumberOfRowsDownW2 = new JLabel("N. linhas: ");
		txtfNumberOfRowsDownW2 = new JTextField();
		txtfNumberOfRowsDownW2.setText("" + rows);
		txtfNumberOfRowsDownW2.setColumns(3);
		lblNumberOfColumnsDownW2 = new JLabel("N. colunas: ");
		txtfNumberOfColumnsDownW2 = new JTextField();
		txtfNumberOfColumnsDownW2.setText("" + columns);
		txtfNumberOfColumnsDownW2.setColumns(3);

		gbc.anchor = GridBagConstraints.WEST;
		gbc.gridy = 0;		gbc.gridx = 0;
		gbc.weightx = 0;
		gb.setConstraints(lblNumberOfRowsDownW2, gbc);
		gbc.gridx = 1;
		gbc.weightx = 0.5;
		gb.setConstraints(txtfNumberOfRowsDownW2, gbc);
		gbc.anchor = GridBagConstraints.EAST;
		gbc.gridx = 2;
		gb.setConstraints(lblNumberOfColumnsDownW2, gbc);
		gbc.gridx = 3;
		gbc.weightx = 0;
		gb.setConstraints(txtfNumberOfColumnsDownW2, gbc);

		pnlW2DownC1.add(lblNumberOfRowsDownW2);
		pnlW2DownC1.add(txtfNumberOfRowsDownW2);
		pnlW2DownC1.add(lblNumberOfColumnsDownW2);
		pnlW2DownC1.add(txtfNumberOfColumnsDownW2);

System.out.print(" 2 ");

		// Configura o JPanel pnlE2DownC1.
		setKernelCells(rows, columns);

System.out.print(" 3 ");

		// Configura o JPanel pnlW1DownRoot.
		createListOfPredefinedKernels();


		// Configura o JPanel pnlS2DownC1.
		// Carrega os botes de controle.

		GridBagLayout gb1 = new GridBagLayout();
		GridBagConstraints gbc1 = new GridBagConstraints();
		pnlS2DownC1.setLayout(gb1);
//////		pnlS2DownC1.setBorder(new LineBorder(new Color(0, 160, 0), 1));

		btnOkDownS2 		= new JButton("Ok      ");
		btnCancelDownS2 		= new JButton("Cancel  ");
		btnCreateMatrixDownS2 	= new JButton("Atualiza");
		btnClearMatrixDownS2 	= new JButton("Limpa   ");

		gbc1.fill = GridBagConstraints.BOTH;
		gbc1.gridx = 0; 	   gbc1.gridy = 0;
		gbc1.weightx = 0.25;
		gb1.setConstraints(btnCreateMatrixDownS2, gbc1);
		gbc1.gridx = 2;
		gb1.setConstraints(btnClearMatrixDownS2, gbc1);
		gbc1.gridx = 4;
		gb1.setConstraints(btnOkDownS2, gbc1);
		gbc1.gridx = 6;
		gb1.setConstraints(btnCancelDownS2, gbc1);

		btnOkDownS2.addActionListener(new ReturnKernelListener());
		btnCancelDownS2.addActionListener(new CancelListener());
		btnCreateMatrixDownS2.addActionListener(new ResizeKernelListener());
		btnClearMatrixDownS2.addActionListener(new ClearKernelListener());

		pnlS2DownC1.add(btnOkDownS2);
		pnlS2DownC1.add(btnCancelDownS2);
		pnlS2DownC1.add(btnCreateMatrixDownS2);
		pnlS2DownC1.add(btnClearMatrixDownS2);
	
System.out.print(" 4 ");

		// Configura o JPanel pnlC1DownRoot.
		//  Esse  o painel principal que suporta os controles do kernel e
		// o prprio kernel.
		GridBagLayout gb2 = new GridBagLayout();
		pnlC1DownRoot.setLayout(gb2);
		GridBagConstraints gbc2 = new GridBagConstraints();

		gbc2.anchor = GridBagConstraints.NORTH;
		gbc2.fill = GridBagConstraints.HORIZONTAL;
		gbc2.gridwidth = GridBagConstraints.REMAINDER;
		gbc2.gridx = 0; gbc2.gridy = 0;
		gbc2.insets = new Insets(2, 2, 0, 0);
		gb2.setConstraints(pnlW2DownC1, gbc2);

		gbc2.anchor = GridBagConstraints.SOUTH;
		gbc2.gridy = GridBagConstraints.RELATIVE;
		gbc2.insets = new Insets(2, 0, 0, 2);
		gb2.setConstraints(pnlS2DownC1, gbc2);

		gbc2.fill = GridBagConstraints.NONE;
		gbc2.anchor = GridBagConstraints.CENTER;
		gbc2.gridwidth = GridBagConstraints.RELATIVE; gbc2.gridheight = GridBagConstraints.RELATIVE;
		gbc2.gridx = GridBagConstraints.RELATIVE; gbc2.gridy = GridBagConstraints.RELATIVE;
		gbc2.insets = new Insets(1, 1, 1, 1);
		gbc2.weighty = 1;
		gb2.setConstraints(pnlE2DownC1, gbc2);

		pnlC1DownRoot.add(pnlW2DownC1);
		pnlC1DownRoot.add(pnlE2DownC1);
		pnlC1DownRoot.add(pnlS2DownC1);


		//  Configura o JDialog root.
		//  Arruma os componentes no JDialog.
		Container rootContentPane = root.getContentPane();
		rootContentPane.setLayout(new BorderLayout());

		lblTitleDownC1 = new JLabel(" Crie o kernel que deseja usar na convoluo. ");
		lblTitleDownC1.setFont(new Font(lblTitleDownC1.getFont().getFontName(), Font.BOLD, lblTitleDownC1.getFont().getSize() + 6));
//////		lblTitleDownC1.setBorder(new LineBorder(new Color(0, 0, 60), 3));

		rootContentPane.add(BorderLayout.WEST, pnlW1DownRoot);
		rootContentPane.add(BorderLayout.CENTER, pnlC1DownRoot);
		rootContentPane.add(BorderLayout.NORTH, lblTitleDownC1);

		root.pack();
		root.setVisible(showIt);
		return krnlRetVal;
	}


	public float [] getCellsValues()
	{
		float [] retVal = new float[arrayTxtfCellsDownE2.length];
		int i = -1;
		while (++i < arrayTxtfCellsDownE2.length)
			retVal[i] = Float.parseFloat(arrayTxtfCellsDownE2[i].getText().trim());
		return retVal;
	}


	public void clearCells()
	{
		int i = -1;
		while (++i < arrayTxtfCellsDownE2.length)
			arrayTxtfCellsDownE2[i].setText("  ");
	}


/**
 *	Rotina que cria uma matriz de text fields de dimenses numberOfRows e os
 * adiciona no panel correspondente.
 */
	public void setKernelCells(int numberOfRows, int numberOfColumns)
	{
		this.rows = numberOfRows;
		this.columns = numberOfColumns;
		pnlE2DownC1.removeAll();

		GridBagLayout gb = new GridBagLayout();
		GridBagConstraints gbc = new GridBagConstraints();
		pnlE2DownC1.setLayout(gb);
		gbc.gridy = -1; gbc.fill = GridBagConstraints.BOTH;

		arrayTxtfCellsDownE2= new JTextField[numberOfRows*numberOfColumns];
		int i = -1;
		while (++i < arrayTxtfCellsDownE2.length)
		{
			if (i%numberOfColumns == 0)	{gbc.gridy++; gbc.gridx = 0;}
			else					 gbc.gridx++;
			arrayTxtfCellsDownE2[i] = new JTextField("");
			arrayTxtfCellsDownE2[i].setColumns(3);
			arrayTxtfCellsDownE2[i].setBorder(new LineBorder(new Color(0, 0, 0), 1));
			gb.setConstraints(arrayTxtfCellsDownE2[i], gbc);
			pnlE2DownC1.add(arrayTxtfCellsDownE2[i]);
		}
		pnlE2DownC1.setBorder(new EtchedBorder(EtchedBorder.RAISED, new Color(200, 200, 240), new Color(100, 100, 170)));
		pnlE2DownC1.setBackground(Color.black);
		root.pack();
	}


/**
 *	Rotina que cria os botes com os kernels pr-prontos e os adiciona na lista de botes.
 * Os botes ao serem pressionados alteram a matriz de textFields atravs de listeners e os
 * adiciona no panel correspondente.
 */
	public void createListOfPredefinedKernels()
	{
		lblKernelsDownW1 = new JLabel("kernels:");
		mapPredefinedKernels = new HashMap();

//%//
		// Filtro de deteco de bordas.
		addKernel("Edge detection", new Kernel(3, 3, new float [] {0f, -1f,  0f, 
											    -1f,  4f, -1f, 
											     0f, -1f,  0f}));

//%//
		// Filtro de deteco de sharpening.
		addKernel("Sharpen", new Kernel(3, 3, new float [] 	{0f, -1f,  0f, 
											-1f,  5f, -1f, 
											 0f, -1f,  0f}));

//%//
		// Filtro de deceteo de sharpening.
		addKernel("Blur", new Kernel(3, 3, new float [] 	{1.0f/9.0f, 1.0f/9.0f, 1.0f/9.0f, 
											 1.0f/9.0f, 1.0f/9.0f, 1.0f/9.0f, 
											 1.0f/9.0f, 1.0f/9.0f, 1.0f/9.0f}));
//%//
		// Filtro de deceteo de sharpening.
		addKernel("MyFilter", new Kernel(3, 3, new float [] 	{1f,  0f, 1f, 
											 0f, -3f, 0f, 
											 1f,  0f, 1f}));

		listPredefinedKernelsDownW1 = new JList(getKeys());
		listPredefinedKernelsDownW1.addListSelectionListener(new SelectPredefinedKernelListener());
		pnlW1DownRoot.setLayout(new BorderLayout());
		pnlW1DownRoot.setBorder(new LineBorder(new Color(20, 20, 80), 2));
		pnlW1DownRoot.add(lblKernelsDownW1, BorderLayout.NORTH);
		pnlW1DownRoot.add(new JScrollPane(listPredefinedKernelsDownW1), BorderLayout.CENTER);
	}


/**
 *	S usar depois de inicializar com createListOfPredefinedKernels().
 */
	public void addKernel(String name, Kernel kernel)	{mapPredefinedKernels.put(name, kernel);}
	public Object [] getKeys()					{return mapPredefinedKernels.keySet().toArray();}
	public Kernel getKernel(Object str)				{return (Kernel) mapPredefinedKernels.get(str);}



// Abaixo, esto os listeners usados.

	public class ReturnKernelListener implements ActionListener
	{	
		public ReturnKernelListener()		{}


		public void actionPerformed(ActionEvent evt)
		{
			float [] celValues = null;
			try	{celValues = getCellsValues();}
			catch(NumberFormatException  exp)
			{
				JOptionPane.showMessageDialog(root.getContentPane(), " necessrio preencher todos os campos do kernel.");
				return;
			}
			krnlRetVal  = new Kernel(rows, columns, celValues);
			root.setVisible(false);
		}
	}


	public class CancelListener implements ActionListener
	{	
		public CancelListener()					{}
		public void actionPerformed(ActionEvent evt)	{root.setVisible(false);}
	}


	public class ClearKernelListener implements ActionListener
	{	
		public ClearKernelListener()				{}
		public void actionPerformed(ActionEvent evt)	{clearCells();}
	}


	public class ResizeKernelListener implements ActionListener
	{	
		public ResizeKernelListener()		{}


		public void actionPerformed(ActionEvent evt)
		{
			int numberOfRows = 0, numberOfColumns = 0;
			try	{numberOfRows = Integer.parseInt(txtfNumberOfRowsDownW2.getText().trim());}
			catch(NumberFormatException  exp)
			{
				txtfNumberOfRowsDownW2.setText("" + rows);
				txtfNumberOfColumnsDownW2.setText("" + columns);
				return;	
			}
			try	{numberOfColumns = Integer.parseInt(txtfNumberOfColumnsDownW2.getText().trim());}
			catch(NumberFormatException  exp)
			{
				txtfNumberOfRowsDownW2.setText("" + rows);
				txtfNumberOfColumnsDownW2.setText("" + columns);
				return;	
			}
			setKernelCells(numberOfRows, numberOfColumns);
		}
	}


	public class SelectPredefinedKernelListener implements ListSelectionListener
	{
		public SelectPredefinedKernelListener()	{}


		public void valueChanged(ListSelectionEvent evt)
		{
			Kernel krnlThis = getKernel(((JList) evt.getSource()).getModel().getElementAt(((JList) evt.getSource()).getSelectedIndex()));
			txtfNumberOfRowsDownW2.setText("" + krnlThis.getWidth());
			txtfNumberOfColumnsDownW2.setText("" + krnlThis.getHeight());
			(new ResizeKernelListener()).actionPerformed(new ActionEvent(evt.getSource(), 1, evt.toString()));			
			float [] elements = krnlThis.getKernelData(null);
			int i = -1;
			while (++i < arrayTxtfCellsDownE2.length)
				arrayTxtfCellsDownE2[i].setText("" + ((int)(elements[i]*100))/100f);
		}
	}
}