package rob.GUI;

import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import javax.swing.plaf.basic.*;
import javax.swing.plaf.metal.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.geom.*;
import java.util.List;
import java.util.LinkedList;
import java.util.ListIterator;


public class TransformChooser
{
	public static final int Scale = 1;
	public static final int Rotate = 2;
	public static final int Translate = 3;

	private JDialog root;
	private JPanel pnlCDownRoot;
	private JPanel pnlSDownRoot;

	private JLabel lblTitleDownRoot;

	private JLabel lblVar1DownC;
	private JLabel lblVar2DownC;
	private JLabel lblVar3DownC;
	private JTextField txtfVar1DownC;
	private JTextField txtfVar2DownC;
	private JTextField txtfVar3DownC;
	private JLabel lblUnit1DownC;
	private JLabel lblUnit2DownC;
	private JLabel lblUnit3DownC;

	private JButton btnOkDownS;
	private JButton btnCancelDownS;

	
	private AffineTransform trfRetVal;

	public TransformChooser()
	{
		trfRetVal  = null;
		root = null;
	}


	public AffineTransform createRotateChooser(Component rooty, boolean showIt)
	{
		return this.createTrf1BoxChooser(rooty, showIt, "Rotacionar Polgono", "ngulo :", "rad", "0", new ReturnRotateListener(), new CancelListener());
	}


	public AffineTransform createRotateOverPointChooser(Component rooty, boolean showIt)
	{
		return this.createTrf3BoxesChooser(rooty, showIt, "Rotacionar Polgono", "ngulo :", "Centro de rotao (X): ", "Centro de rotao (Y): ", "rad", "pixels", "pixels", "0", "100", "100", new ReturnRotateOverPointListener(), new CancelListener());
	}


	public AffineTransform createTranslateChooser(Component rooty, boolean showIt)
	{
		return this.createTrf2BoxesChooser(rooty, showIt, "Transladar Polgono", "DX:", "DY:", "pixels", "pixels", "0", "0", new ReturnTranslateListener(), new CancelListener());
	}


	public AffineTransform createScaleChooser(Component rooty, boolean showIt)
	{
		return this.createTrf2BoxesChooser(rooty, showIt, "Escalar Polgono", "Escala X:", "Escala Y:", "%", "%", "100", "100", new ReturnScaleListener(), new CancelListener());
	}


	protected AffineTransform createTrf1BoxChooser(Component rooty, boolean showIt, String title, String nameVar1, String unitVar1, String defaultVar1, ActionListener okListener, ActionListener cancelListener)
	{
		Frame rootRoot = GUIFactory.getFrameForComponent(rooty);
		root = new JDialog(rootRoot, "Scale chooser", true);

		// Cria todos os containters.
		pnlCDownRoot = new JPanel();
		pnlSDownRoot = new JPanel();

		// Configura primeiro o JPanel pnlCDownRoot.
		GridBagLayout gb = new GridBagLayout();
		GridBagConstraints gbc = new GridBagConstraints();
		pnlCDownRoot.setLayout(gb);
//////		pnlCDownRoot.setBorder(new LineBorder(new Color(50, 50, 180), 1));
//////		pnlCDownRoot.setBackground(new Color(160, 160, 160));

		lblVar1DownC = new JLabel(nameVar1);
		txtfVar1DownC = new JTextField();
		txtfVar1DownC.setText(defaultVar1);
		txtfVar1DownC.setColumns(3);
		lblUnit1DownC = new JLabel(unitVar1);

		gbc.anchor = GridBagConstraints.WEST;
		gbc.fill = GridBagConstraints.HORIZONTAL;
		gbc.gridy = 0;		gbc.gridx = 0;
		gbc.weightx = 0.5;
		gb.setConstraints(lblVar1DownC, gbc);
		gbc.anchor = GridBagConstraints.CENTER;
		gbc.fill = GridBagConstraints.HORIZONTAL;
		gbc.gridx = 1;
		gbc.weightx = 0.5;
		gb.setConstraints(txtfVar1DownC, gbc);
		gbc.anchor = GridBagConstraints.WEST;
		gbc.fill = GridBagConstraints.NONE;
		gbc.gridx = 2;
		gbc.weightx = 0;
		gb.setConstraints(lblUnit1DownC, gbc);

		pnlCDownRoot.add(lblVar1DownC);
		pnlCDownRoot.add(txtfVar1DownC);
		pnlCDownRoot.add(lblUnit1DownC);

		// Configura o JPanel pnlSDownRoot.
		gb = new GridBagLayout();
		gbc = new GridBagConstraints();
		pnlSDownRoot.setLayout(gb);
		pnlSDownRoot.setBorder(new LineBorder(new Color(50, 50, 180), 1));
		pnlSDownRoot.setBackground(new Color(160, 160, 160));

		btnOkDownS = new JButton("OK");
		btnCancelDownS = new JButton("Cancel");

		gbc.anchor = GridBagConstraints.CENTER;
		gbc.gridy = 0;		gbc.gridx = 0;
		gbc.insets = new Insets(5, 5, 5, 5);
		gb.setConstraints(btnOkDownS, gbc);
		gbc.gridx = 1;
		gb.setConstraints(btnCancelDownS, gbc);

		btnOkDownS.addActionListener(okListener);
		btnCancelDownS.addActionListener(cancelListener);

		pnlSDownRoot.add(btnOkDownS);
		pnlSDownRoot.add(btnCancelDownS);

		//  Configura o JDialog root. Arruma os componentes no JDialog.
		gb = new GridBagLayout();
		gbc = new GridBagConstraints();
		Container rootContentPane = root.getContentPane();
		rootContentPane.setLayout(gb);

		lblTitleDownRoot = new JLabel(title);
		lblTitleDownRoot.setFont(new Font(lblTitleDownRoot.getFont().getFontName(), Font.BOLD, lblTitleDownRoot.getFont().getSize() + 4));

		gbc.anchor = GridBagConstraints.CENTER;
		gbc.fill = GridBagConstraints.HORIZONTAL;
		gbc.gridy = 0;		gbc.gridx = 0;
		gbc.insets = new Insets(5, 5, 5, 5);
		gb.setConstraints(lblTitleDownRoot, gbc);
		gbc.fill = GridBagConstraints.BOTH;
		gbc.gridy = 1;
		gb.setConstraints(pnlCDownRoot, gbc);
		gbc.fill = GridBagConstraints.HORIZONTAL;
		gbc.gridy = 2;
		gb.setConstraints(pnlSDownRoot, gbc);

		rootContentPane.add(lblTitleDownRoot);
		rootContentPane.add(pnlCDownRoot);
		rootContentPane.add(pnlSDownRoot);

		root.pack();
		root.setVisible(showIt);
		return trfRetVal;
	}


	protected AffineTransform createTrf2BoxesChooser(Component rooty, boolean showIt, String title, String nameVar1, String nameVar2, String unitVar1, String unitVar2, String defaultVar1, String defaultVar2, ActionListener okListener, ActionListener cancelListener)
	{
		Frame rootRoot = GUIFactory.getFrameForComponent(rooty);
		root = new JDialog(rootRoot, "Scale chooser", true);

System.out.print(" 1 ");

		// Cria todos os containters.
		pnlCDownRoot = new JPanel();
		pnlSDownRoot = new JPanel();

System.out.print(" 1.1 ");

		// Configura primeiro o JPanel pnlCDownRoot.
		GridBagLayout gb = new GridBagLayout();
		GridBagConstraints gbc = new GridBagConstraints();
		pnlCDownRoot.setLayout(gb);
//////		pnlCDownRoot.setBorder(new LineBorder(new Color(50, 50, 180), 1));
//////		pnlCDownRoot.setBackground(new Color(160, 160, 160));

		lblVar1DownC = new JLabel(nameVar1);
		lblVar2DownC = new JLabel(nameVar2);
		txtfVar1DownC = new JTextField();
		txtfVar1DownC.setText(defaultVar1);
		txtfVar1DownC.setColumns(3);
		txtfVar2DownC = new JTextField();
		txtfVar2DownC.setText(defaultVar2);
		txtfVar2DownC.setColumns(3);
		lblUnit1DownC = new JLabel(unitVar1);
		lblUnit2DownC = new JLabel(unitVar2);

		gbc.anchor = GridBagConstraints.WEST;
		gbc.fill = GridBagConstraints.HORIZONTAL;
		gbc.gridy = 0;		gbc.gridx = 0;
		gbc.weightx = 0.5;
		gb.setConstraints(lblVar1DownC, gbc);
		gbc.anchor = GridBagConstraints.CENTER;
		gbc.fill = GridBagConstraints.HORIZONTAL;
		gbc.gridx = 1;
		gbc.weightx = 0.5;
		gb.setConstraints(txtfVar1DownC, gbc);
		gbc.anchor = GridBagConstraints.WEST;
		gbc.fill = GridBagConstraints.NONE;
		gbc.gridx = 2;
		gbc.weightx = 0;
		gb.setConstraints(lblUnit1DownC, gbc);
		gbc.anchor = GridBagConstraints.WEST;
		gbc.gridy = 1;		gbc.gridx = 0;
		gbc.weightx = 0.5;
		gb.setConstraints(lblVar2DownC, gbc);
		gbc.anchor = GridBagConstraints.CENTER;
		gbc.fill = GridBagConstraints.HORIZONTAL;
		gbc.gridx = 1;
		gbc.weightx = 0.5;
		gb.setConstraints(txtfVar2DownC, gbc);
		gbc.anchor = GridBagConstraints.WEST;
		gbc.fill = GridBagConstraints.NONE;
		gbc.gridx = 2;
		gbc.weightx = 0;
		gb.setConstraints(lblUnit2DownC, gbc);

		pnlCDownRoot.add(lblVar1DownC);
		pnlCDownRoot.add(txtfVar1DownC);
		pnlCDownRoot.add(lblUnit1DownC);
		pnlCDownRoot.add(lblVar2DownC);
		pnlCDownRoot.add(txtfVar2DownC);
		pnlCDownRoot.add(lblUnit2DownC);

System.out.print(" 2 ");

		// Configura o JPanel pnlSDownRoot.
		gb = new GridBagLayout();
		gbc = new GridBagConstraints();
		pnlSDownRoot.setLayout(gb);
		pnlSDownRoot.setBorder(new LineBorder(new Color(50, 50, 180), 1));
		pnlSDownRoot.setBackground(new Color(160, 160, 160));

		btnOkDownS = new JButton("OK");
		btnCancelDownS = new JButton("Cancel");

		gbc.anchor = GridBagConstraints.CENTER;
		gbc.gridy = 0;		gbc.gridx = 0;
		gbc.insets = new Insets(5, 5, 5, 5);
		gb.setConstraints(btnOkDownS, gbc);
		gbc.gridx = 1;
		gb.setConstraints(btnCancelDownS, gbc);

		btnOkDownS.addActionListener(okListener);
		btnCancelDownS.addActionListener(cancelListener);

		pnlSDownRoot.add(btnOkDownS);
		pnlSDownRoot.add(btnCancelDownS);

try{
System.out.print(" 3 ");

		//  Configura o JDialog root. Arruma os componentes no JDialog.
		gb = new GridBagLayout();
		gbc = new GridBagConstraints();
		Container rootContentPane = root.getContentPane();
		rootContentPane.setLayout(gb);

		lblTitleDownRoot = new JLabel(title);
		lblTitleDownRoot.setFont(new Font(lblTitleDownRoot.getFont().getFontName(), Font.BOLD, lblTitleDownRoot.getFont().getSize() + 4));

		gbc.anchor = GridBagConstraints.CENTER;
		gbc.fill = GridBagConstraints.HORIZONTAL;
		gbc.gridy = 0;		gbc.gridx = 0;
		gbc.insets = new Insets(5, 5, 5, 5);
		gb.setConstraints(lblTitleDownRoot, gbc);
		gbc.fill = GridBagConstraints.BOTH;
		gbc.gridy = 1;
		gb.setConstraints(pnlCDownRoot, gbc);
		gbc.fill = GridBagConstraints.HORIZONTAL;
		gbc.gridy = 2;
		gb.setConstraints(pnlSDownRoot, gbc);

		rootContentPane.add(lblTitleDownRoot);
		rootContentPane.add(pnlCDownRoot);
		rootContentPane.add(pnlSDownRoot);

		root.pack();
		root.setVisible(showIt);
		return trfRetVal;

}catch(Exception exc){System.out.println("CreateScaleTransform-> Exception com texto: " + exc.getLocalizedMessage() + "nome da mesma:" + exc.toString());}
		return null;

	}


	protected AffineTransform createTrf3BoxesChooser(Component rooty, boolean showIt,  String title, String nameVar1, String nameVar2, String nameVar3, String unitVar1, String unitVar2, String unitVar3, String defaultVar1, String defaultVar2, String defaultVar3, ActionListener okListener, ActionListener cancelListener)
	{
try{
		Frame rootRoot = GUIFactory.getFrameForComponent(rooty);
		root = new JDialog(rootRoot, "Scale chooser", true);

System.out.print(" 1 ");

		// Cria todos os containters.
		pnlCDownRoot = new JPanel();
		pnlSDownRoot = new JPanel();

System.out.print(" 1.1 ");

		// Configura primeiro o JPanel pnlCDownRoot.
		GridBagLayout gb = new GridBagLayout();
		GridBagConstraints gbc = new GridBagConstraints();
		pnlCDownRoot.setLayout(gb);
		pnlCDownRoot.setBorder(new LineBorder(new Color(50, 50, 180), 1));
		pnlCDownRoot.setBackground(new Color(160, 160, 160));

		lblVar1DownC = new JLabel(nameVar1);
		lblVar2DownC = new JLabel(nameVar2);
		lblVar3DownC = new JLabel(nameVar3);
		txtfVar1DownC = new JTextField();
		txtfVar1DownC.setText(defaultVar1);
		txtfVar1DownC.setColumns(3);
		txtfVar2DownC = new JTextField();
		txtfVar2DownC.setText(defaultVar2);
		txtfVar2DownC.setColumns(3);
		txtfVar3DownC = new JTextField();
		txtfVar3DownC.setText(defaultVar3);
		txtfVar3DownC.setColumns(3);
		lblUnit1DownC = new JLabel(unitVar1);
		lblUnit2DownC = new JLabel(unitVar2);
		lblUnit3DownC = new JLabel(unitVar3);

		gbc.anchor = GridBagConstraints.WEST;
		gbc.fill = GridBagConstraints.NONE;
		gbc.gridy = 0;		gbc.gridx = 0;
		gbc.weightx = 0;
		gb.setConstraints(lblVar1DownC, gbc);
		gbc.anchor = GridBagConstraints.EAST;
		gbc.fill = GridBagConstraints.HORIZONTAL;
		gbc.gridx = 1;
		gb.setConstraints(txtfVar1DownC, gbc);
		gbc.anchor = GridBagConstraints.WEST;
		gbc.fill = GridBagConstraints.NONE;
		gbc.gridx = 2;
		gb.setConstraints(lblUnit1DownC, gbc);

		gbc.anchor = GridBagConstraints.WEST;
		gbc.gridy = 1;		gbc.gridx = 0;
		gb.setConstraints(lblVar2DownC, gbc);
		gbc.anchor = GridBagConstraints.EAST;
		gbc.fill = GridBagConstraints.HORIZONTAL;
		gbc.gridx = 1;
		gb.setConstraints(txtfVar2DownC, gbc);
		gbc.anchor = GridBagConstraints.WEST;
		gbc.fill = GridBagConstraints.NONE;
		gbc.gridx = 2;
		gb.setConstraints(lblUnit2DownC, gbc);

		gbc.anchor = GridBagConstraints.WEST;
		gbc.gridy = 2;		gbc.gridx = 0;
		gb.setConstraints(lblVar3DownC, gbc);
		gbc.anchor = GridBagConstraints.EAST;
		gbc.fill = GridBagConstraints.HORIZONTAL;
		gbc.gridx = 1;
		gb.setConstraints(txtfVar3DownC, gbc);
		gbc.anchor = GridBagConstraints.WEST;
		gbc.fill = GridBagConstraints.NONE;
		gbc.gridx = 2;
		gb.setConstraints(lblUnit3DownC, gbc);

		pnlCDownRoot.add(lblVar1DownC);
		pnlCDownRoot.add(txtfVar1DownC);
		pnlCDownRoot.add(lblUnit1DownC);
		pnlCDownRoot.add(lblVar2DownC);
		pnlCDownRoot.add(txtfVar2DownC);
		pnlCDownRoot.add(lblUnit2DownC);
		pnlCDownRoot.add(lblVar3DownC);
		pnlCDownRoot.add(txtfVar3DownC);
		pnlCDownRoot.add(lblUnit3DownC);

System.out.print(" 2 ");

		// Configura o JPanel pnlSDownRoot.
		gb = new GridBagLayout();
		gbc = new GridBagConstraints();
		pnlSDownRoot.setLayout(gb);
		pnlSDownRoot.setBorder(new LineBorder(new Color(50, 50, 180), 1));
		pnlSDownRoot.setBackground(new Color(160, 160, 160));

		btnOkDownS = new JButton("OK");
		btnCancelDownS = new JButton("Cancel");

		gbc.anchor = GridBagConstraints.CENTER;
		gbc.gridy = 0;		gbc.gridx = 0;
		gb.setConstraints(btnOkDownS, gbc);
		gbc.gridx = 1;
		gb.setConstraints(btnCancelDownS, gbc);

		btnOkDownS.addActionListener(okListener);
		btnCancelDownS.addActionListener(cancelListener);

		pnlSDownRoot.add(btnOkDownS);
		pnlSDownRoot.add(btnCancelDownS);

System.out.print(" 3 ");

		//  Configura o JDialog root. Arruma os componentes no JDialog.
		gb = new GridBagLayout();
		gbc = new GridBagConstraints();
		Container rootContentPane = root.getContentPane();
		rootContentPane.setLayout(gb);

		lblTitleDownRoot = new JLabel(title);
		lblTitleDownRoot.setFont(new Font(lblTitleDownRoot.getFont().getFontName(), Font.BOLD, lblTitleDownRoot.getFont().getSize() + 6));

		gbc.anchor = GridBagConstraints.CENTER;
		gbc.fill = GridBagConstraints.HORIZONTAL;
		gbc.gridy = 0;		gbc.gridx = 0;
		gb.setConstraints(lblTitleDownRoot, gbc);
		gbc.fill = GridBagConstraints.BOTH;
		gbc.gridy = 1;
		gb.setConstraints(pnlCDownRoot, gbc);
		gbc.fill = GridBagConstraints.HORIZONTAL;
		gbc.gridy = 2;
		gb.setConstraints(pnlSDownRoot, gbc);

		rootContentPane.add(lblTitleDownRoot);
		rootContentPane.add(pnlCDownRoot);
		rootContentPane.add(pnlSDownRoot);

		root.pack();
		root.setVisible(showIt);
		return trfRetVal;

}catch(Exception exc){System.out.println("CreateScaleTransform-> Exception com texto: " + exc.getLocalizedMessage() + "nome da mesma:" + exc.toString());}
		return null;

	}



// Abaixo, esto os listeners usados.

	public class ReturnScaleListener implements ActionListener
	{	
		public ReturnScaleListener()		{}


		public void actionPerformed(ActionEvent evt)
		{
			float var1 = 0, var2 = 0;
			try
			{
				var1 = Float.parseFloat(txtfVar1DownC.getText().trim())/100;
				var2 = Float.parseFloat(txtfVar2DownC.getText().trim())/100;
			}
			catch(NumberFormatException  exp)
			{
				JOptionPane.showMessageDialog(root.getContentPane(), "Os campos devem conter nmeros.");
				return;
			}
			System.out.println("entrou em ReturnScaleListener.");
			trfRetVal  = AffineTransform.getScaleInstance(var1, var2);
			root.setVisible(false);
		}
	}


	public class ReturnTranslateListener implements ActionListener
	{	
		public ReturnTranslateListener()		{}


		public void actionPerformed(ActionEvent evt)
		{
			float var1 = 0, var2 = 0;
			try
			{
				var1 = Float.parseFloat(txtfVar1DownC.getText().trim());
				var2	 = Float.parseFloat(txtfVar2DownC.getText().trim());
			}
			catch(NumberFormatException  exp)
			{
				JOptionPane.showMessageDialog(root.getContentPane(), "Os campos devem conter nmeros.");
				return;
			}
			trfRetVal  = AffineTransform.getTranslateInstance(var1, var2);
			root.setVisible(false);
		}
	}


	public class ReturnRotateListener implements ActionListener
	{	
		public ReturnRotateListener()		{}


		public void actionPerformed(ActionEvent evt)
		{
			float var1 = 0;
			try
			{
				var1 = Float.parseFloat(txtfVar1DownC.getText().trim());
			}
			catch(NumberFormatException  exp)
			{
				JOptionPane.showMessageDialog(root.getContentPane(), "Os campos devem conter nmeros.");
				return;
			}
			trfRetVal  = AffineTransform.getRotateInstance(var1);
			root.setVisible(false);
		}
	}


	public class ReturnRotateOverPointListener implements ActionListener
	{	
		public ReturnRotateOverPointListener()	{}


		public void actionPerformed(ActionEvent evt)
		{
			float var1 = 0, var2 = 0, var3 = 0;
			try
			{
				var1 = Float.parseFloat(txtfVar1DownC.getText().trim());
				var2 = Float.parseFloat(txtfVar2DownC.getText().trim());
				var3 = Float.parseFloat(txtfVar3DownC.getText().trim());
			}
			catch(NumberFormatException  exp)
			{
				JOptionPane.showMessageDialog(root.getContentPane(), "Os campos devem conter nmeros.");
				return;
			}
			trfRetVal  = AffineTransform.getRotateInstance(var1, var2, var3);
			root.setVisible(false);
		}
	}


	public class CancelListener implements ActionListener
	{	
		public CancelListener()					{}
		public void actionPerformed(ActionEvent evt)	{root.setVisible(false);}
	}
}