package rob.math.geom;

import java.util.List;
import java.util.ListIterator;
import java.awt.Shape;
import java.awt.geom.Point2D;

public interface IPolygonIterator extends ListIterator
{

/**
 *	Diferentemente de ListIterator.next(),  retornado null quando no h
 * prximo elemento em vez de ser lanada uma exceo. O mesmo vale para 
 * previous.
 */


/**
 *	Adiciona ponto aps o ponto que foi retornado.
 */
	public int addAfter(Point2D newPoint);

/**
 *	Adiciona ponto antes do ponto que foi retornado.
 */
	public int addBefore(Point2D newPoint);

/**
 *	Elimina o proximo ponto do ponto que foi retornado.
 */
	public int removeNext();

/**
 *	Elimina o ponto anterior ao ponto que foi retornado.
 */
	public int removePrevious();

/**
 *	No iterator, todas as operaes so implementadas em tempo O(1).
 * O ponto trabalhado  o ltimo retornado seja por next ou previous.
 */
	// Retorna a INSTACIA.
	public Point2D getPoint();
	public double getX();
	public double getY();
	public void setPoint(Point2D newPoint);
	public void setY(double newX);
	public void setX(double newY);
}