package rob.math.geom;


import java.awt.geom.Point2D;


public final class PolygonOperations
{
	private PolygonOperations() {}


	public static boolean isOnBoundaryOf(Point2D ptComp, IPolygon poly, double precision)
	{
		IPolygonIterator polyIt = poly.polygonIterator();
		Point2D p1 = null, p2 = null;
		if (!polyIt.hasNext())
			return false;
		p2 = (Point2D) polyIt.next();
		while (polyIt.hasNext())
		{
			p1 = p2; p2 = (Point2D) polyIt.next();
			if (Math.abs(GeomOperations.area2(p1, p2, ptComp)) < precision) return true;
		}
		p1 = p2; p2 = poly.getPoint(0);
		if (Math.abs(GeomOperations.area2(p1, p2, ptComp)) < precision)	return true;
		else											return false;
	}


//////	public static boolean intersects(IPolygon poly1, IPolygon poly2)
//////	{
//////		return true;
//////	}
}