package rob.math.geom;

import java.awt.Color;
import java.awt.Stroke;
import java.awt.BasicStroke;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.geom.Point2D;
import java.awt.geom.Line2D;
import java.util.Collection;
import java.util.List;
import java.util.LinkedList;
import java.util.Iterator;
import rob.math.*;
import rob.util.*;
import rob.exceptions.*;


public class SegmentsCrossings
{
	boolean prop = true;
	EventStruct eventStruct;


	public SegmentsCrossings() 	{eventStruct = new EventStruct();}
	public SegmentsCrossings(int improp) 	{eventStruct = new EventStruct(improp); prop = false;}

	public SegmentsCrossings(Collection newLines)
	{
		this();
		Object objTmp = null;
		Iterator tmpIt = newLines.iterator();
		if (tmpIt.hasNext())
			objTmp = tmpIt.next();
		else
			return;
		if (objTmp instanceof Point2D)
		{
			int i = 0;
			Point2D p1 = (Point2D) objTmp;
			Point2D p2 = null;
			while (tmpIt.hasNext())
			{
				if ((++i)%2 == 0)
					p1 = (Point2D) tmpIt.next();
				else
				{
					p2 = (Point2D) tmpIt.next();
					eventStruct.insertSegment(p1, p2);
				}
			}
		}
		else if (objTmp instanceof Line2D)
		{
			eventStruct.insertSegment((Line2D) objTmp);
			while (tmpIt.hasNext())
				eventStruct.insertSegment((Line2D) tmpIt.next());
		}
	}	


	public SegmentsCrossings(IPolygon newLines) 
	{
		this();
		Iterator tmpIt = newLines.iterator();
		Point2D p1 = null;
		Point2D p2 = null;
		int i = -1;
		if (tmpIt.hasNext())
			p2 = (Point2D) tmpIt.next();
		while (tmpIt.hasNext())
		{
			p1 = p2;
			p2 = (Point2D) tmpIt.next();
			eventStruct.insertSegment(p1, p2);
		}
		eventStruct.insertSegment(p2, (Point2D) newLines.get(0));
	}


	public SegmentsCrossings(Collection newLines, int improp)
	{
		this(improp);
		Object objTmp = null;
		Iterator tmpIt = newLines.iterator();
		if (tmpIt.hasNext())
			objTmp = tmpIt.next();
		else
			return;
		if (objTmp instanceof Point2D)
		{
			int i = 0;
			Point2D p1 = (Point2D) objTmp;
			Point2D p2 = null;
			while (tmpIt.hasNext())
			{
				if ((++i)%2 == 0)
					p1 = (Point2D) tmpIt.next();
				else
				{
					p2 = (Point2D) tmpIt.next();
					eventStruct.insertSegment(p1, p2);
				}
			}
		}
		else if (objTmp instanceof Line2D)
		{
			eventStruct.insertSegment((Line2D) objTmp);
			while (tmpIt.hasNext())
				eventStruct.insertSegment((Line2D) tmpIt.next());
		}
	}	


	public SegmentsCrossings(IPolygon newLines, int improp) 
	{
		this(improp);
		Iterator tmpIt = newLines.iterator();
		Point2D p1 = null;
		Point2D p2 = null;
		int i = -1;
		if (tmpIt.hasNext())
			p2 = (Point2D) tmpIt.next();
		while (tmpIt.hasNext())
		{
			p1 = p2;
			p2 = (Point2D) tmpIt.next();
			eventStruct.insertSegment(p1, p2);
		}
		eventStruct.insertSegment(p2, (Point2D) newLines.get(0));
	}


	public void insertSegment(Point2D p1, Point2D p2)	{eventStruct.insertSegment(p1, p2);}
	public void insertSegment(Line2D line)	{eventStruct.insertSegment(line);}
	

	public List getCrossingsDebug(Graphics2D g)
	{
		g.setColor(Color.red);
		g.setStroke(new BasicStroke(2, BasicStroke.CAP_BUTT, BasicStroke.JOIN_BEVEL, 2));

		SweepLine sweepLine = new SweepLine();
		AVLTerminatedTree.AVLNode actualEvent = eventStruct.getNextAndDelete();
		AVLTerminatedTree.AVLNode actualSweepLineEvent = null;
		SweepLine.SweepLineKey actualSweepLineKey = null;
		EventStruct.EventStructKey actualEventStructKey = null;
		List crossings = new LinkedList();
		int i = -1;
		String s = null;
		while (actualEvent != null)
		{
			i++;
			actualEventStructKey = (EventStruct.EventStructKey) actualEvent.key;

			if (actualEventStructKey.type == EventStruct.BEGIN)
			{
s = "BEGIN:";
				actualSweepLineEvent = actualEventStructKey.sweepNode;
				actualSweepLineKey = (SweepLine.SweepLineKey) actualSweepLineEvent.key;
System.out.print(s + " actualSweepLineEvent:(" + ((SweepLine.SweepLineKey) actualSweepLineEvent.key).p1.getX() + ", " + ((SweepLine.SweepLineKey) actualSweepLineEvent.key).p1.getY() + ")");
System.out.println("");
sweepLine.traverse(AVLTerminatedTree.IN_ORDER);
System.out.println("");
				sweepLine.insert(actualSweepLineEvent);
System.out.println("");
sweepLine.traverse(AVLTerminatedTree.IN_ORDER);
System.out.println("");
				AVLTerminatedTree.AVLNode lowerSweepLineEvent = sweepLine.getAntecessor(actualSweepLineEvent);
				if (lowerSweepLineEvent != null)
				{
s += " lowerSweepLineEvent:(" + ((SweepLine.SweepLineKey) lowerSweepLineEvent.key).p1.getX() + ", " + ((SweepLine.SweepLineKey) lowerSweepLineEvent.key).p1.getY() + ")";
					AVLTerminatedTree.AVLNode possibleCrossEvent = getCrossEvent(lowerSweepLineEvent, actualSweepLineEvent);
					if (possibleCrossEvent != null)
						eventStruct.insertEvent(possibleCrossEvent);
				}
s += " actualSweepLineEvent:(" + ((SweepLine.SweepLineKey) actualSweepLineEvent.key).p1.getX() + ", " + ((SweepLine.SweepLineKey) actualSweepLineEvent.key).p1.getY() + ")";
				AVLTerminatedTree.AVLNode upperSweepLineEvent = sweepLine.getSuccessor(actualSweepLineEvent);
				if (upperSweepLineEvent != null)
				{
s += " upperSweepLineEvent:(" + ((SweepLine.SweepLineKey) upperSweepLineEvent.key).p1.getX() + ", " + ((SweepLine.SweepLineKey) upperSweepLineEvent.key).p1.getY() + ")";
					AVLTerminatedTree.AVLNode possibleCrossEvent = getCrossEvent(actualSweepLineEvent, upperSweepLineEvent);
					if (possibleCrossEvent != null)
						eventStruct.insertEvent(possibleCrossEvent);
				}
				g.drawString(s, 0, i*15);
			}
			else if (actualEventStructKey.type == EventStruct.END)
			{
s = "END:";
				actualSweepLineEvent = actualEventStructKey.sweepNode;
				actualSweepLineKey = (SweepLine.SweepLineKey) actualSweepLineEvent.key;
				AVLTerminatedTree.AVLNode lowerSweepLineEvent = sweepLine.getAntecessor(actualSweepLineEvent);
				AVLTerminatedTree.AVLNode upperSweepLineEvent = sweepLine.getSuccessor(actualSweepLineEvent);
System.out.print(s + " actualSweepLineEvent:(" + ((SweepLine.SweepLineKey) actualSweepLineEvent.key).p1.getX() + ", " + ((SweepLine.SweepLineKey) actualSweepLineEvent.key).p1.getY() + ")");
System.out.println("");
sweepLine.traverse(AVLTerminatedTree.IN_ORDER);
System.out.println("");
				sweepLine.delete(actualSweepLineEvent);
System.out.println("");
sweepLine.traverse(AVLTerminatedTree.IN_ORDER);
System.out.println("");
				if (lowerSweepLineEvent != null && upperSweepLineEvent != null)
				{
s += " lowerSweepLineEvent:(" + ((SweepLine.SweepLineKey) lowerSweepLineEvent.key).p1.getX() + ", " + ((SweepLine.SweepLineKey) lowerSweepLineEvent.key).p1.getY() + ")";
s += " actualSweepLineEvent:(" + ((SweepLine.SweepLineKey) actualSweepLineEvent.key).p1.getX() + ", " + ((SweepLine.SweepLineKey) actualSweepLineEvent.key).p1.getY() + ")";
s += " upperSweepLineEvent:(" + ((SweepLine.SweepLineKey) upperSweepLineEvent.key).p1.getX() + ", " + ((SweepLine.SweepLineKey) upperSweepLineEvent.key).p1.getY() + ")";
					AVLTerminatedTree.AVLNode possibleCrossEvent = getCrossEvent(lowerSweepLineEvent, upperSweepLineEvent);
					if (possibleCrossEvent != null)
						eventStruct.insertEvent(possibleCrossEvent);
				}
				else
s += " actualSweepLineEvent:(" + ((SweepLine.SweepLineKey) actualSweepLineEvent.key).p1.getX() + ", " + ((SweepLine.SweepLineKey) actualSweepLineEvent.key).p1.getY() + ")";
				g.drawString(s, 0, i*15);
			}
			else // (actualEventStructKey.type == EventStruct.CROSS)
			{
s = "CROSS:";
				g.drawOval((int) actualEventStructKey.pEvt.getX() - 1, (int) actualEventStructKey.pEvt.getY() - 1, 2, 2);
				crossings.add(actualEventStructKey.pEvt);
				EventStruct.EventCrossKey actualEventCrossKey = (EventStruct.EventCrossKey) actualEventStructKey;
System.out.print(s + " successorNode:(" + ((SweepLine.SweepLineKey) actualEventCrossKey.successorNode.key).p1.getX() + ", " + ((SweepLine.SweepLineKey) actualEventCrossKey.successorNode.key).p1.getY() + ")");

System.out.println("");
sweepLine.traverse(AVLTerminatedTree.IN_ORDER);
System.out.println("");
				// swapWithSuccessor  conferido pois podem ocorrer casos quando a interseco 
				// imprpria ou muito prxima as extremidades onde o valor do ponto de interseco
				//  calculado como sendo um pouco maior do que realmente , fazendo o ponto de interseco
				// aparecer na EventStruct depois que um dos segmentos que compe a interseso j tiver
				// sido eliminado da SweepLine, ou aparecer antes de tal segemnto entrar na SweepLine. Caso
				// ocorra um dos dois casos, swapWithSuccessor detecta que um dos segmentos no est na estrutura
				// e retorna false, impendindo que segmentos que nada tenham a ver sejam invertidos destruindo a
				// estrutura. Com essa tcnica pode-se perder algubns pontos de interseco, mas evita-se loops 
				// inifitos. Para vermos que isso no afeta a corretude do algoritmo, basta verificarmos que essa
				// tcnica equivale a encolher um pouco uma das retas, fazendo com que ele se extingue (ou comece)
				// um pouco antes (ou pouco depois) da interseco ocorrer.
				if (sweepLine.swapWithSuccessor(actualEventCrossKey.antecessorNode, actualEventCrossKey.successorNode))
				{
System.out.println("");
sweepLine.traverse(AVLTerminatedTree.IN_ORDER);
System.out.println("");

					// Agora, antecessorNode est acima de successorNode.
					AVLTerminatedTree.AVLNode lowerLowerSweepLineEvent = sweepLine.getAntecessor(actualEventCrossKey.successorNode);
					if (lowerLowerSweepLineEvent != null)
					{
s += " lowerLowerSweepLineEvent:(" + ((SweepLine.SweepLineKey) lowerLowerSweepLineEvent.key).p1.getX() + ", " + ((SweepLine.SweepLineKey) lowerLowerSweepLineEvent.key).p1.getY() + ")";
						AVLTerminatedTree.AVLNode possibleCrossEvent = getCrossEvent(lowerLowerSweepLineEvent, actualEventCrossKey.successorNode);
						if (possibleCrossEvent != null)
							eventStruct.insertEvent(possibleCrossEvent);
					}
s += " successorNode:(" + ((SweepLine.SweepLineKey) actualEventCrossKey.successorNode.key).p1.getX() + ", " + ((SweepLine.SweepLineKey) actualEventCrossKey.successorNode.key).p1.getY() + ")";
s += " antecessorNode:(" + ((SweepLine.SweepLineKey) actualEventCrossKey.antecessorNode.key).p1.getX() + ", " + ((SweepLine.SweepLineKey) actualEventCrossKey.antecessorNode.key).p1.getY() + ")";
					AVLTerminatedTree.AVLNode upperUpperSweepLineEvent = sweepLine.getSuccessor(actualEventCrossKey.antecessorNode);
					if (upperUpperSweepLineEvent != null)
					{
s += " upperUpperSweepLineEvent:(" + ((SweepLine.SweepLineKey) upperUpperSweepLineEvent.key).p1.getX() + ", " + ((SweepLine.SweepLineKey) upperUpperSweepLineEvent.key).p1.getY() + ")";
						AVLTerminatedTree.AVLNode possibleCrossEvent = getCrossEvent(actualEventCrossKey.antecessorNode, upperUpperSweepLineEvent);
						if (possibleCrossEvent != null)
							eventStruct.insertEvent(possibleCrossEvent);
					}
if (lowerLowerSweepLineEvent == actualEventCrossKey.successorNode)
{
	g.setColor(Color.red);
	g.drawOval(100 + i*10, 100 + i*10, 5, 5);
	return null;
}
if (upperUpperSweepLineEvent == actualEventCrossKey.successorNode)
{
	g.setColor(Color.yellow);
	g.drawOval(100 + i*10, 100 + i*10, 5, 5);
	return null;
}
if (lowerLowerSweepLineEvent == actualEventCrossKey.antecessorNode)
{
	g.setColor(Color.blue);
	g.drawOval(100 + i*10, 100 + i*10, 5, 5);
	return null;
}
if (lowerLowerSweepLineEvent == upperUpperSweepLineEvent && upperUpperSweepLineEvent != null)
{
	g.setColor(Color.green);
	g.drawOval(100 + ++i*10, 100 + i*10, 5, 5);
	g.setColor(Color.blue);
				g.drawString(s, 100 + i*10+6, 100 + i*10+6);
	return null;
}
				}
				g.drawString(s, 0, i*15);
			}
System.out.println("");
eventStruct.traverse(AVLTerminatedTree.IN_ORDER);
System.out.println("");
eventStruct.traverse(AVLTerminatedTree.PRE_ORDER);
System.out.println("");
			actualEvent = eventStruct.getNextAndDelete();
		}
		return crossings;
	}


	public boolean hasCrossings()
	{
		SweepLine sweepLine = new SweepLine();
		AVLTerminatedTree.AVLNode actualEvent = eventStruct.getNextAndDelete();
		AVLTerminatedTree.AVLNode actualSweepLineEvent = null;
		SweepLine.SweepLineKey actualSweepLineKey = null;
		EventStruct.EventStructKey actualEventStructKey = null;
		while (actualEvent != null)
		{
			actualEventStructKey = (EventStruct.EventStructKey) actualEvent.key;

			if (actualEventStructKey.type == EventStruct.BEGIN)
			{
				actualSweepLineEvent = actualEventStructKey.sweepNode;
				actualSweepLineKey = (SweepLine.SweepLineKey) actualSweepLineEvent.key;
				sweepLine.insert(actualSweepLineEvent);
				AVLTerminatedTree.AVLNode lowerSweepLineEvent = sweepLine.getAntecessor(actualSweepLineEvent);
				if (lowerSweepLineEvent != null)
				{
					AVLTerminatedTree.AVLNode possibleCrossEvent = getCrossEvent(lowerSweepLineEvent, actualSweepLineEvent);
					if (possibleCrossEvent != null)
						return true;
				}
				AVLTerminatedTree.AVLNode upperSweepLineEvent = sweepLine.getSuccessor(actualSweepLineEvent);
				if (upperSweepLineEvent != null)
				{
					AVLTerminatedTree.AVLNode possibleCrossEvent = getCrossEvent(actualSweepLineEvent, upperSweepLineEvent);
					if (possibleCrossEvent != null)
						return true;
				}
			}
			else if (actualEventStructKey.type == EventStruct.END)
			{
				actualSweepLineEvent = actualEventStructKey.sweepNode;
				actualSweepLineKey = (SweepLine.SweepLineKey) actualSweepLineEvent.key;
				AVLTerminatedTree.AVLNode lowerSweepLineEvent = sweepLine.getAntecessor(actualSweepLineEvent);
				AVLTerminatedTree.AVLNode upperSweepLineEvent = sweepLine.getSuccessor(actualSweepLineEvent);
				sweepLine.delete(actualSweepLineEvent);
				if (lowerSweepLineEvent != null && upperSweepLineEvent != null)
				{
					AVLTerminatedTree.AVLNode possibleCrossEvent = getCrossEvent(lowerSweepLineEvent, upperSweepLineEvent);
					if (possibleCrossEvent != null)
						return true;
				}
			}
			actualEvent = eventStruct.getNextAndDelete();
		}
		return false;
	}


	public AVLTerminatedTree.AVLNode getCrossEvent(AVLTerminatedTree.AVLNode antecessorNode, AVLTerminatedTree.AVLNode successorNode)
	{
		SweepLine.SweepLineKey antecessorKey = (SweepLine.SweepLineKey) antecessorNode.key;
		SweepLine.SweepLineKey successorKey = (SweepLine.SweepLineKey) successorNode.key;

		boolean intersects = prop ? GeomOperations.intersect(antecessorKey.p1, antecessorKey.p2, successorKey.p1, successorKey.p2) :
						    GeomOperations.intersectImprop(antecessorKey.p1, antecessorKey.p2, successorKey.p1, successorKey.p2);
		if (!intersects)
			return null;
		else
		{	
			double x, y;
			if (antecessorKey.p2.getX() - antecessorKey.p1.getX() == 0)
			{
				x = antecessorKey.p1.getX();
				y = (successorKey.p2.getY() - successorKey.p1.getY())/(successorKey.p2.getX() - successorKey.p1.getX())*(x - successorKey.p1.getX()) + successorKey.p1.getY();
			}
			else if (successorKey.p2.getX() - successorKey.p1.getX() == 0)
			{
				x = successorKey.p1.getX();
				y = (antecessorKey.p2.getY() - antecessorKey.p1.getY())/(antecessorKey.p2.getX() - antecessorKey.p1.getX())*(x - antecessorKey.p1.getX()) + antecessorKey.p1.getY();
			}
			else
			{	
				double m1 = (antecessorKey.p2.getY() - antecessorKey.p1.getY())/(antecessorKey.p2.getX() - antecessorKey.p1.getX());
				double m2 = (successorKey.p2.getY() - successorKey.p1.getY())/(successorKey.p2.getX() - successorKey.p1.getX());
				x = (m1*antecessorKey.p1.getX() - m2*successorKey.p1.getX() + successorKey.p1.getY() - antecessorKey.p1.getY())/(m1 - m2);
				y = m2*x - m2*successorKey.p1.getX() + successorKey.p1.getY();
			}
			if (!prop)
			{
				x = ((double)((long) (x*10000)))/10000.0;
				y = ((double)((long) (y*10000)))/10000.0;
			}
			Point2D pNew = new Point2D.Double(x, y);
			return eventStruct.createEventStructNode(pNew, antecessorNode, successorNode);
		}
	}
}