package rob.math.geom;


import java.awt.geom.*;
import java.util.Comparator;
import rob.util.*;


public class SweepLine extends AVLTerminatedTree
{
	public SweepLine()
	{
		super(new SweepLineComparator(), new SweepLineResolutor(), new AVLTerminatedTree.TerminatorFactory());
	}


	public void insert(AVLTerminatedTree.AVLNode thisNode)
	{
		addNode(thisNode);
	}


	public void delete(AVLTerminatedTree.AVLNode thisNode)
	{	
		deleteNode(thisNode);
	}


	public AVLTerminatedTree.AVLNode getSuccessor(AVLTerminatedTree.AVLNode thisNode)
	{
		if (size <= 1)
			return null;
		else if (thisNode.right instanceof Terminator)
		{
			if (thisNode.parent == head)
				return null;

			// thisNode  filho esquerdo.
			else if (thisNode.parent.left == thisNode)
				return thisNode.parent;

			// thisNode  filho direito.
			else
			{
				while (thisNode.parent.right == thisNode)
					thisNode = thisNode.parent;
				if (thisNode.parent != head)
					return thisNode.parent;
				else
					return null;
			}
		}
		else if (thisNode.right.left instanceof Terminator)
			return thisNode.right;
		else
		{
			thisNode = thisNode.right.left;
			while (!(thisNode.left instanceof Terminator))
				thisNode = thisNode.left;
			return thisNode;
		}
	}


	public AVLTerminatedTree.AVLNode getAntecessor(AVLTerminatedTree.AVLNode thisNode)
	{
		if (thisNode == head)
			return null;
		else if (thisNode.left instanceof Terminator)
		{
			if (thisNode.parent == head)
				return null;

			// thisNode  filho direito.
			else if (thisNode.parent.right == thisNode)
				return thisNode.parent;

			// thisNode  filho esquerdo.
			else
			{
				while (thisNode.parent != head && thisNode.parent.left == thisNode)
					thisNode = thisNode.parent;
				if (thisNode.parent != head)
					return thisNode.parent;
				else
					return null;
			}
		}
		else if (thisNode.left.right instanceof Terminator)
			return thisNode.left;
		else
		{
			thisNode = thisNode.left.right;
			while (!(thisNode.right instanceof Terminator))
				thisNode = thisNode.right;
			return thisNode;
		}
	}


	public boolean swapWithSuccessor(AVLTerminatedTree.AVLNode thisNode, AVLTerminatedTree.AVLNode successorNode)
	{
		if (thisNode.parent.left != thisNode && thisNode.parent.right != thisNode && 
		thisNode.left.parent != thisNode && thisNode.right.parent != thisNode) 
			return false;
		if (successorNode.parent.left != successorNode && successorNode.parent.right != successorNode && 
		successorNode.left.parent != successorNode && successorNode.right.parent != successorNode)
			return false;

		AVLTerminatedTree.AVLNode nodeTmp = null;
		int tmpBalance = 0;

System.out.print("<swapWithSuccessor>");
		// Nenhum aponta pro outro.
		if (thisNode.parent != successorNode && successorNode.parent != thisNode)
		{
System.out.print("<Nenhum aponta pro outro>");
			if  (thisNode.parent.left == thisNode)
				thisNode.parent.left = successorNode;
			else
				thisNode.parent.right = successorNode;
			thisNode.left.parent   = successorNode;
			thisNode.right.parent  = successorNode;
			if  (successorNode.parent.left == successorNode)
				successorNode.parent.left = thisNode;
			else
				successorNode.parent.right = thisNode;
			successorNode.left.parent   = thisNode;
			successorNode.right.parent  = thisNode;
			nodeTmp = thisNode.left; thisNode.left = successorNode.left; successorNode.left = nodeTmp;
			nodeTmp = thisNode.right; thisNode.right = successorNode.right; successorNode.right = nodeTmp;
			nodeTmp = thisNode.parent; thisNode.parent = successorNode.parent; successorNode.parent = nodeTmp;
			tmpBalance = thisNode.balance; thisNode.balance = successorNode.balance; successorNode.balance = tmpBalance;
		}

		// successorNode  filho de thisNode ou thisNode  filho de successorNode.
		else
		{
System.out.print("<successorNode  filho de thisNode ou thisNode  filho de successorNode>");
			// thisNode  filho de successorNode.
			if (successorNode.parent != thisNode)
			{
				nodeTmp = thisNode; thisNode = successorNode; successorNode = nodeTmp;
			}

if (successorNode.parent == null) System.out.print("2successorNode.parent == null");
if (successorNode.left == null) System.out.print("2successorNode.left == null");
if (successorNode.right == null) System.out.print("2successorNode.right == null");
if (thisNode.parent == null) System.out.print("2thisNode.parent == null");
if (thisNode.left == null) System.out.print("2thisNode.left == null");
if (thisNode.right == null) System.out.print("2thisNode.right == null");

			if  (thisNode.parent.left == thisNode)
				thisNode.parent.left = successorNode;
			else
				thisNode.parent.right = successorNode;
			successorNode.left.parent   = thisNode;
			successorNode.right.parent  = thisNode;
			successorNode.parent = thisNode.parent; thisNode.parent = successorNode;
			tmpBalance = thisNode.balance; thisNode.balance = successorNode.balance; successorNode.balance = tmpBalance;

			// successorNode  filho esquerdo de thisNode.
			if (thisNode.left == successorNode)
			{
				thisNode.right.parent  = successorNode;
				nodeTmp = thisNode.right; thisNode.right = successorNode.right; successorNode.right = nodeTmp;
				thisNode.left = successorNode.left; successorNode.left = thisNode;
			}

			// successorNode  filho direito de thisNode.
			else
			{
				thisNode.left.parent  = successorNode;
				nodeTmp = thisNode.left; thisNode.left = successorNode.left; successorNode.left = nodeTmp;
				thisNode.right = successorNode.right; successorNode.right = thisNode;
			}
		}
if (successorNode.parent.left != successorNode && successorNode.parent.right != successorNode) System.out.print("successorNode.parent.left != successorNode && successorNode.parent.right != successorNode");
if (successorNode.left.parent != successorNode) System.out.print("successorNode.left.parent != successorNode");
if (successorNode.right.parent != successorNode) System.out.print("successorNode.right.parent != successorNode");
if (thisNode.parent.left != thisNode && thisNode.parent.right != thisNode) System.out.print("thisNode.parent.left != thisNode && thisNode.parent.right != thisNode");
if (thisNode.left.parent != thisNode) System.out.print("thisNode.left.parent != thisNode");
if (thisNode.right.parent != thisNode) System.out.print("thisNode.right.parent != thisNode");
		return true;
	}


	public static AVLTerminatedTree.AVLNode createSweepLineNode(Point2D pA, Point2D pB, int ownerPolygon)
	{
		return new AVLTerminatedTree.AVLNode(new SweepLineKey(pA, pB), new SweepLineElement(ownerPolygon));
	}


	public static class SweepLineKey
	{
		// p2 ser sempre maior ou igual a p1 com relao a:
		// 1- x-coordenada.
		// 2- y-coordenada.
		public Point2D p1 = null, p2 = null;


		public SweepLineKey(Point2D pA, Point2D pB)
		{
			if (GeomOperations.compareByX(pA, pB) >= 0)	{p1 = pB; p2 = pA;}
			else								{p1 = pA; p2 = pB;}
		}


		public String toString()
		{
			return "p1:(" + p1.getX() + ", " + p1.getY() + ")";
		}
	}


	public static class SweepLineElement
	{
		public int owner;


		public SweepLineElement(int ownerNew)
		{
			owner = ownerNew;
		}
	}


	public static class SweepLineComparator implements Comparator
	{
		// O evento sendo inserido  sempre o1.
		public int compare(Object o1, Object o2)
		{
			SweepLineKey key1 = (SweepLineKey) o1;
			SweepLineKey key2 = (SweepLineKey) o2;
			double area2 = GeomOperations.area2(key2.p1, key2.p2, key1.p1);
			if (area2 != 0)
				return area2 > 0 ? 1 : -1;
			else
			{
				area2 = GeomOperations.area2(key2.p1, key2.p2, key1.p2);
				if (area2 != 0)
					return area2 > 0 ? 1 : -1;
				else
				{
					System.out.println("Merda! SweepLineComparator = 0");
					return 0;
				}
			}				
		}
	}


	public static class SweepLineResolutor implements Resolutor
	{		
		public int resolve(INodeMap nodeOne, INodeMap nodeTwo)
		{
			return 0;
		}


		public int resolveKeys(Object keyOne, Object keyTwo)
		{
			return 0;
		}
	}
}